!     Simulation for CC Discharging

	SUBROUTINE DRIVE11(MAXORD,LRW1,LIW1,NRT1,RPAR,IDID,TDAT,YMO2,NOBS)
	INTEGER NEQ,MAXORD,LRW1,LIW1,IRES,iremt,IPAR(1),INFO(30),
	1 IWK(LIW1),NRT1
	integer jroot(NRT1)

	DOUBLE PRECISION Y(NEQ),YPRIME(NEQ),DELTA(NEQ),ATOL(NEQ),
	1 RTOL(NEQ),DTOUT,dtout1,DTOUT0,DTOUT01,
     2ATOL1,RTOL1,ATOL2
	DOUBLE PRECISION TDAT(NOBS),YMO2(7,NOBS),RTOL2,iapp
	DOUBLE PRECISION   T, TOUT, RWORK(LRW1),RPAR(23)
	INTEGER IWORK(LIW1),SENPAR
	
	common/input11/Node,Nae,Neq
	common/iapprel/iapp
	common/err/rtol1,atol1,RTOL2,ATOL2,dtout0,dtout01,
	1nout

	EXTERNAL  DRES111, DJAC111, RTX211, ICs11
!	nout = nobs
      t=0.d0

	DO 115 I = 1,30
115	INFO(I) = 0
!C      INPUT ATOL AND RTOL ARRAY
!C        FIRST NTOL ELEMENTS USE ATOL1, RTOL1 VALUES
	INFO(2)=1
	DO ITOL=1,Node
	ATOL(ITOL)=ATOL1
	RTOL(ITOL)=RTOL1
	ENDDO
!C        NEXT (NEQ-NTOL) ELEMENTS USE ATOL2, RTOL2 VALUES
	DO ITOL=Node+1,NEQ
 	ATOL(ITOL)=ATOL2
 	RTOL(ITOL)=RTOL2
	ENDDO

	INFO(8)=1
	Rwork(3)=1.0D-2

	do i=1,Neq
	iwork(40+i)=2
	enddo

	do i=Node+1,Neq
	iwork(40+i)=-1
	enddo


	INFO(11)=1

	CALL ICs11(Y,RPAR)
	
	do i=1,NEQ
	YPRIME(i)=1
	enddo

	call DRES111(T,Y,YPRIME,cj,DELTA,IRES,RPAR,IPAR,SENPAR)
	
	CALL RESULTS11(T,Y,YPRIME,DELTA)	

	Tout=0.D0

	DO 125 I = 1,NOUT
	
	tout=tout+DTOUT01
	
120	CALL DDASKR (DRES111, NEQ, T, Y, YPRIME, TOUT, INFO, RTOL, ATOL,
     1   IDID, RWORK, LRW1, IWORK, LIW1, RPAR, IPAR, DJAC111, PSOL,
	2   SENPAR, G_RES, K_RES, T_RES, A_RES,
     3   RTX211, NRT1, JROOT)

	YMO2(1,I)=Y(1)
	YMO2(2,I)=Y(2)
	YMO2(3,I)=Y(3)
	YMO2(4,I)=Y(4)
	YMO2(5,I)=Y(5)
	YMO2(6,I)=Y(6)
	YMO2(7,I)=Y(7)
	

	CALL RESULTS11(T,Y,YPRIME,DELTA)
	IF (IDID .EQ. 5) GOTO 181
	IF (IDID .LT. 1) GOTO 179

125	CONTINUE
127	FORMAT(1(F))		
	
	return

179	WRITE(*,*) IDID
180	FORMAT(//1X,'Simulation Failed',/)
	CLOSE(2)
	
181	return

	END


	SUBROUTINE RESULTS11(T,Y,YPRIME,DELTA)
!===========================================================================================================
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	DIMENSION Y(*),YPRIME(*),DELTA(*)
	common/input11/Node,Nae,Neq
	common/iapprel/iapp

	Integer neq1

	neq1 = neq+1

420	FORMAT(1X,<NEQ1>(F13.8))

	RETURN
	END


	SUBROUTINE RTX211(NEQ, T, Y, YP, NRT, RVAL, RPAR, IPAR)
!=================================================================================================
	IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Y(*), YP(*), RVAL(NRT)

	RVAL(1)=Y(7)-0.8    ! Cutoff voltage for discharge

	RETURN
	END


	SUBROUTINE DJAC111(T,Y,YPRIME,PD,CJ,RPAR,IPAR,SENPAR)
!===============================================================================================================
      IMPLICIT NONE
      INTEGER IPAR(*)
      DOUBLE PRECISION T,Y(*),YPRIME(*),PD(*),CJ,RPAR(*),SENPAR
	
	RETURN
	END  