	subroutine my_grad(x_current,xl,xu,f1,NN,nobs,YDATA,jacob_f)
	
	double precision x_current(NN),f1,x_pert(NN),xl(NN),xu(NN)
	double precision jacob_f(NN,1),f_pert(NN,1),f_pert_ii(NN,1)
	double precision YDATA(2,200)

	integer NN,ii,i1,i2,i3,i4,j1,nobs
		 
	do ii=1,NN
		jacob_f(ii,1) = 0.D0 !Jacobian initialization
		f_pert(ii,1) = 0.D0
		f_pert_ii(ii,1) = 0.D0
	enddo
    
	do i3 = 1,NN
	  x_pert(i3) = 0.0001D0*(xu(i3)-xl(i3))	
        x_current(i3) = x_current(i3) + x_pert(i3) !1st perturbation in ith decision variable - 1 forward difference step - for Jacobian calculation
        if (isnan(f1) .eq. 0) then
		  call estimate(x_current,nn,nobs,YDATA,f_pert(i3,1))
		  jacob_f(i3,1) = (f_pert(i3,1) - f1)/x_pert(i3) ! Jacobian evaluation - derivative of objective wrt perturbed decision variable
        endif
	  x_current(i3) = x_current(i3) - x_pert(i3) ! Returning back
	enddo
    
	return
	end
